#!/usr/bin/perl

if ($#ARGV == 0) { open(IN,"<$ARGV[0]"); }
else {open(IN,"<fort.32");}

#$pre = 1.12930392E-09;  # 2000 K
$pre = 7.98538462E-10;  # 1000 K

@dump = (<IN>);

for ($i=0;$i<=$#dump;$i++) {
	$line = $dump[$i];
	@dat = split/ +/,$line;
	$traj = $dat[1];
	$surf = $dat[2];
	$outcome = $dat[3];
	$p1= $dat[4];
	$p2= $dat[5];
	$tdelay= $dat[6];

	if ($outcome < 0) {
		$fail++; }
	else {
		($outmax > $outcome) || ($outmax = $outcome);
		($surfmax > $surf) || ($surfmax = $surf);
		$key = $surf."-".$outcome;
		$count{$key}++;
		$prob1{$key} += $p1;
		$prob2{$key} += $p2;
		$count{"tot"}++;
		$prob1{"tot"} += $p1;
		$prob2{"tot"} += $p2;
	}
}

print "\n";
print " Surf Outcome      N           P             +/-           <P1>           <P2>            k            kerr             %err\n";
$n=$count{"tot"};
for ($i=1;$i<=$outmax;$i++) {
for ($j=1;$j<=$surfmax;$j++) {
$key = $j."-".$i;
if ($count{$key} > 0) {
$nr=$count{$key};
$p = $nr/$n;
$perr = $p*sqrt(($n-$nr)/($nr*$n));
$p1 = $prob1{$key}/$nr;
$p2 = $prob2{$key}/$nr;
printf ("% 5i",$j);
printf ("% 5i",$i);
printf ("% 10i",$nr);
printf ("% 15.5f",$p);
printf ("% 15.5f",$perr);
printf ("% 15.5f",$p1);
printf ("% 15.5f",$p2);
printf ("% 15.5e",$pre*$p);
printf ("% 15.5e",$pre*$perr);
printf ("% 15.5f",100.*$perr/$p);
print "\n";
$ptot += $p;
}
}
}
$p1 = $prob1{"tot"}/$n;
$p2 = $prob2{"tot"}/$n;
print "    Totals";
printf ("% 10i",$n);
printf ("% 15.5f",$ptot);
printf ("% 15.5f",0.);
printf ("% 15.5f",$p1);
printf ("% 15.5f",$p2);
print "\n";



# bin probs
$plo = 0;
$phi = 1;
$pgrid = 0.1;

for ($i=0;$i<=$#dump;$i++) {
	$line = $dump[$i];
	@dat = split/ +/,$line;
	$surf = $dat[2];
	$outcome = $dat[3];
	$p1= $dat[4];
	$p2= $dat[5];
	if ($outcome >= 0) {
		$ind=int(($p2-$plo)/$pgrid);
		$key = $surf."-".$outcome."-".$ind;
		$pbin{$key}++;
		($ind <= $indmax) || ($indmax = $ind);
		if ($p2 > 0.5) {$hist2++;}
	}
}

print "\n";
print "\n";
print "     prob          surf1           surf2         total\n";
for ($k=0;$k<=$indmax;$k++) {
$lo = $k*$pgrid;
$hi = $lo+$pgrid;
$key1 = "1-1-".$k;
$key2 = "2-1-".$k;
printf ("% 6.1f",$lo);
printf ("% 6.1f",$hi);
if ($count{"1-1"}  > 0 ) {printf ("% 15.5f",$pbin{$key1}/$count{"1-1"}*100.);} else {printf ("% 15.5f",0.);}
if ($count{"2-1"}  > 0 ) {printf ("% 15.5f",$pbin{$key2}/$count{"2-1"}*100.);} else {printf ("% 15.5f",0.);}
printf ("% 15.5f",($pbin{$key1}+$pbin{$key2})/$count{"tot"}*100.);
print "\n";
}
print "\n";
print "Hist2 = ".($hist2/$count{"tot"})."\n";







