      program deltaedown
      implicit double precision(a-h,o-z)

      parameter(mdat=550000)
      parameter(mtemp=5000)
      parameter(mttt=30)
      parameter(mobs=40)
      parameter(nx=3)
      dimension idat(mobs),dat(mobs),ttt(mttt),zz(mttt),
     &  deltae(mttt,nx),deltaed(mttt,nx),deltaed2(mttt,nx),
     &  deltae2(mttt,nx),zlj(mttt),deltaj(mttt,nx),deltajd(mttt,nx),
     &  derotd(mttt),deltaeu(mttt,nx),deltaju(mttt,nx),
     &  deltaeu2(mttt,nx),deltaju2(mttt,nx),deltaj2(mttt,nx),
     &  deltajd2(mttt,nx),deltaedjd(mttt,nx),deltaeuju(mttt,nx),
     &  deltaedju(mttt,nx),deltaeujd(mttt,nx),deltae3(mttt,nx),
     &  deltaeu3(mttt,nx),deltaed3(mttt,nx),deltaej(mttt,nx),
     &  deltaju3(mttt,nx),deltajd3(mttt,nx),deltaj3(mttt,nx),
     &  avgj(nx),avgjju(nx),avgjjd(nx),avgjeu(nx),avgjed(nx),
     &  avgjuu(nx),avgjdd(nx),avgjud(nx),avgjdu(nx)
      dimension su(mdat),sd(mdat),sju(mdat),sjd(mdat),suu(mdat),
     & sud(mdat),sdu(mdat),sdd(mdat),sd2(mdat),su2(mdat),sjd2(mdat),
     & sju2(mdat),sm(mdat),ded(mdat),djd(mdat),dwd(mdat)
      character*3 m1,m2
      integer bsample,maxw(mttt)
      double precision jnorm(0:mtemp),mind,maxd
      integer traj,state,outcome,dnd
      double precision li,j1i,j2i,lf,j1f,j2f,kbev,kbcmi,
     & maxediffi,maxedifff

      jdble=3 ! calculate dble moments from 0 to jdble-1

c      open(10,file="fort.31")
c      read (10,*)ntraj,bsample,bmax,m1,m2,tsampmin
      read (5,*)ntraj,bsample,bmax,m1,m2,tsampmin
      if (ntraj.gt.mdat) then
         print *,"Increase MDAT to ",ntraj
         stop
      endif

      nttt = 1    ! list of temperatures for output
      ttt(1)=tsampmin

c constants 
      evtocmi = 8065.7208
      evtoau = 1./27.211
      kbev = 8.61692d-05
      kbcmi = 0.695016d0
      pi=dacos(-1.d0)
      dsmall=2.d0/evtocmi ! 2 cm-1
      djsmall=.02d0 ! 0.02 hbar
      dsmall=1.d0/evtocmi 
      djsmall=.01d0 
c      dsmall=0.00002d0/evtocmi ! 2 cm-1
c      djsmall=.0000002d0 ! 0.02 hbar

c print
      print *,m1," + ",m2," collisions "
      print *,ntraj," trajectories"
      if(bsample.eq.1) print *,"b was sampled evenly (0,",bmax,")"
      if(bsample.eq.2) print *,"b**2 was sampled evenly (0,",bmax,"**2)"
      print *

c compute Z/Z
      print *,"   T,K    ZHS/ZLJ     ZHS cm3/s    ZLJ cm3/s"
      do i=1,nttt
      call zonz(ttt(i),bmax,m1,m2,zz(i),zhs,zlj(i))
      print *," ",ttt(i)," ",zz(i),zhs,zlj(i)
      enddo

c initialize
       etotdmax = -1.d0
       tt=-1.d0
       ttmin=1d10
       ttmax=-1d10
       ttav=0.d0

       etriav=0.d0
       etotiav=0.d0
       etotdmax=-1.d0
       etotdmue=0.d0
       etotdrms=0.d0
       eeiavg=0.d0
       xjavg=0.d0

       maxd=0.d0
       mind=0.d0
       maxediffi=0.d0
       maxedifff=0.d0

       bav=0.d0

       nt=0
       md=0
       wd=0
       wu=0
       wt=0
       mm=0
       mu=0
       mjd=0
       mju=0
       mdd=0
       mdu=0
       mud=0
       muu=0

       dnd=0
       dnw=0

       nsmall=0
       njsmall=0
       nsmallr=0
       nsmallj=0

       do k=1,jdble
       avgj(k)=0.d0
       avgjju(k)=0.d0
       avgjjd(k)=0.d0
       avgjeu(k)=0.d0
       avgjed(k)=0.d0
       avgjdd(k)=0.d0
       avgjuu(k)=0.d0
       avgjud(k)=0.d0
       avgjdu(k)=0.d0
       do i=1,nttt
       deltae(i,k)=0.d0
       deltaej(i,k)=0.d0
       deltae2(i,k)=0.d0
       deltae3(i,k)=0.d0
       deltaed(i,k)=0.d0
       deltaed2(i,k)=0.d0
       deltaed3(i,k)=0.d0
       deltaeu(i,k)=0.d0
       deltaeu2(i,k)=0.d0
       deltaeu3(i,k)=0.d0
       deltaj(i,k)=0.d0
       deltaj2(i,k)=0.d0
       deltaj3(i,k)=0.d0
       deltajd(i,k)=0.d0
       deltajd2(i,k)=0.d0
       deltajd3(i,k)=0.d0
       deltaju(i,k)=0.d0
       deltaju2(i,k)=0.d0
       deltaju3(i,k)=0.d0
       deltaedjd(i,k)=0.d0
       deltaeuju(i,k)=0.d0
       enddo
       enddo

c loop over trajectories
       nobs=32
       if (nbos.gt.mobs) then
         print *,"Increase NOBS to ",nobs
         stop
       endif
       do it=1,ntraj
       read (5,*)(idat(j),j=1,3),(dat(j),j=4,nobs)
c       read (10,*)(idat(j),j=1,3),(dat(j),j=4,nobs)

        traj = idat(1)
        state = idat(2)
        outcome = idat(3)
        time = dat(4)
        temp = dat(5)
        temps = dat(6)
        bi = dat(7)
        li = dat(8)
        eorbi = dat(9)
        ereli = dat(10)
        vi = dat(11)
        j1i = dat(12)
        erot1i = dat(13)
        evib1i = dat(14)
        v1i = dat(15)
        j2i = dat(16)
        erot2i = dat(17)
        evib2i = dat(18)
        v2i = dat(19)
        vf = dat(20)
        lf = dat(21)
        eorbf = dat(22)
        erelf = dat(23)
        j1f = dat(24)
        erot1f = dat(25)
        evib1f = dat(26)
        v1f = dat(27)
        j2f = dat(28)
        erot2f = dat(29)
        evib2f = dat(30)
        v2f = dat(31)
        tt = dat(32) 
        k1i=0.

! Check energy error due to finite fragment separation
        ediffi = vi-v1i-v2i
        edifff = vf-v1f-v2f
        if (dabs(edifff)*evtocmi.gt.1.d3) then
           print *,"Vf = ",edifff*evtocmi," (traj ",it,")"
           outcome = 3 
           write(11,*)bi,traj
        endif

! Total energy
        eei = vi+erot1i+evib1i+erot2i+evib2i
        etoti = eorbi+ereli+vi+erot1i+evib1i+erot2i+evib2i
        etotf = eorbf+erelf+vf+erot1f+evib1f+erot2f+evib2f
        etotd = etotf-etoti
        if (dabs(etotd)*evtocmi.gt.10.) then
           print *,"Delta E = ",etotd*evtocmi," (traj ",it,")"
           outcome = 3
        endif

! check for bad trajectories
        iskip=0
        if (outcome.eq.0.or.outcome.ge.2) then
                print *,"Outcome = ",outcome," (traj ",it,")"
                iskip=1
        endif
c        if (bi.gt.bmax) iskip=1

        IF (iskip.eq.0) THEN
        nt=nt+1

! sampling temperature; compute max, min, avg
        if (tt.gt.ttmax) ttmax = tt
        if (tt.lt.ttmin) ttmin = tt
        ttav = ttav+tt

! Check energy conservation, avg, mue, rms, max
        etotiav = etotiav + etoti
        etotdmue = etotdmue + dabs(etotd)
        etotdrms = etotdrms + (etotd)**2
        if (dabs(etotd).gt.etotdmax) itetotdmax = it
        if (dabs(etotd).gt.etotdmax) etotdmax = dabs(etotd)

! Check energy error due to finite fragment separation
        ediffi = vi-v1i-v2i
        edifff = vf-v1f-v2f
        if (dabs(ediffi).gt.maxediffi) maxediffitraj = it
        if (dabs(edifff).gt.maxedifff) maxediffftraj = it
        maxediffi=max(dabs(ediffi),maxediffi)
        maxedifff=max(dabs(edifff),maxedifff)
        avgediffi=avgediffi+dabs(ediffi)
        avgedifff=avgedifff+dabs(edifff)

! Initial translational energy (orbital + relative) & average
        etri = eorbi+ereli
        etriav = etriav + etri

! Impact parameter
        bav = bav + bi                                  ! compute average impact parameter b

! Delta J
        delj = j1f - j1i
        if (dabs(delj).lt.djsmall) then
           delj=djsmall/2.d0
           njsmall=njsmall+1
           if (mod(njsmall,2).eq.0) delj=-djsmall/2.d0
        endif

! Delta E
        delr = erelf+eorbf-ereli-eorbi                 ! change in trans energy
        delf1 = erot1f+evib1f+v1f-(erot1i+evib1i+v1i)      ! change in internal energy
        delf2 = erot2f+evib2f+v2f-(erot2i+evib2i+v2i)      ! change in internal energy
        if (v1i.eq.0d0.and.v2i.eq.0d0) then 
!       if LDOFRAG=.false.
        d = -delr                                         ! delta E 
        else
!       if LDOFRAG=.true., e.g., for a molecular collider
        d = delf1                                        ! delta E 
        endif
c        d = (-delr+delf1)/2.d0                           ! avg seems to work; needs more testing

c TEMP ROT/VIB CH4 B
        drot=(j1f*(j1f+1.d0)-(j1i*(j1i+1.d0)))*5.24d0/evtocmi  ! quantal in eV
        drot=(j1f*j1f-j1i*j1i)*5.24d0/evtocmi  ! classical in eV
        dvib=d-drot
        if (dabs(drot).lt.dsmall) then
           drot=dsmall/2.d0
           nsmallr=nsmallr+1
           if (mod(nsmallr,2).eq.0) drot=-dsmall/2.d0
        endif
        if (dabs(dvib).lt.dsmall) then
           dvib=dsmall/2.d0
           nsmallv=nsmallv+1
           if (mod(nsmallv,2).eq.0) dvib=-dsmall/2.d0
        endif
c END TEMP

        if (dabs(d).lt.dsmall) then
           d=dsmall/2.d0
           nsmall=nsmall+1
           if (mod(nsmall,2).eq.0) d=-dsmall/2.d0
        endif
c        print *,it,bi,dabs(d)*evtocmi,dabs(delj)
        if (d.gt.maxd) then
                 maxd=d
                 maxdit=it
        endif
        if (d.lt.mind) then
                 mind=d
                 mindit=it
        endif
        eeiavg=eeiavg+eei
        xjavg=xjavg+j1i

c        print *,2.d0*bi/bmax,j1i,d*evtocmi,drot*evtocmi,dvib*evtocmi

c save for binw
        b1=0.
        b2=100.
        if (bi.gt.b1.and.bi.lt.b2) then
        ded(it)=d*evtocmi
        djd(it)=delj
        dwd(it)=2.d0*bi/bmax
        dnd=dnd+1
        dnw=dnw+2.d0*bi/bmax
        endif

! loop over output temperatures
        do k=1,nttt
        do kj=1,jdble
        xkj=dble(j1i**(kj-1))
!       Weights
        w = zz(k)                               ! w=Z/Z
        if (bsample.eq.1) w = w*2.d0*bi/bmax    ! w=w*impact parameter b scaling
        deltae(k,kj) = deltae(k,kj) + w*d*xkj
        deltaej(k,kj) = deltaej(k,kj) + w*d*delj*xkj
        deltae2(k,kj) = deltae2(k,kj) + w*d**2*xkj
        deltae3(k,kj) = deltae3(k,kj) + w*d**3*xkj
        deltaj(k,kj)=deltaj(k,kj)+w*delj*xkj
        deltaj2(k,kj)=deltaj2(k,kj)+w*delj**2*xkj
        deltaj3(k,kj)=deltaj3(k,kj)+w*delj**3*xkj
        avgj(kj)=avgj(kj)+xkj
          if (kj.eq.1) then
          mm=mm+1
          sm(mm)=d*evtocmi*w
          endif
        if (delj.lt.0.d0) then
          deltajd(k,kj) = deltajd(k,kj)+w*delj*xkj
          deltajd2(k,kj) = deltajd2(k,kj)+w*delj**2*xkj
          deltajd3(k,kj) = deltajd3(k,kj)+w*delj**3*xkj
          if (kj.eq.1) mjd=mjd+1
          avgjjd(kj)=avgjjd(kj)+xkj
          sjd(mjd)=delj*w
          sjd2(mjd)=delj*w*delj
        elseif (delj.gt.0.d0) then
          deltaju(k,kj) = deltaju(k,kj)+w*delj*xkj
          deltaju2(k,kj) = deltaju2(k,kj)+w*delj**2*xkj
          deltaju3(k,kj) = deltaju3(k,kj)+w*delj**3*xkj
          avgjju(kj)=avgjju(kj)+xkj
          if (kj.eq.1) then
          mju=mju+1
          sju(mju)=delj*w
          sju2(mju)=delj*w*delj
          endif
        else
          print *,"not up or down J",delj,j1i,j1f
          stop
        endif
        if (d.lt.0.d0) then
          deltaed(k,kj) = deltaed(k,kj)+w*d*xkj
          deltaed2(k,kj) = deltaed2(k,kj)+w*d**2*xkj
          deltaed3(k,kj) = deltaed3(k,kj)+w*d**3*xkj
          avgjed(kj)=avgjed(kj)+xkj
          if (kj.eq.1) then
          md=md+1
          wd=wd+2.d0*bi/bmax
          sd(md)=d*evtocmi*w
          sd2(md)=d*evtocmi*w*d*evtocmi
          endif
        elseif (d.gt.0.d0) then
          deltaeu(k,kj) = deltaeu(k,kj)+w*d*xkj
          deltaeu2(k,kj) = deltaeu2(k,kj)+w*d**2*xkj
          deltaeu3(k,kj) = deltaeu3(k,kj)+w*d**3*xkj
          avgjeu(kj)=avgjeu(kj)+xkj
          if (kj.eq.1) then
          mu=mu+1
          wu=wu+2.d0*bi/bmax
          su(mu)=d*evtocmi*w
          su2(mu)=d*evtocmi*w*d*evtocmi
          endif
        else
          print *,"not up or down E"
          stop
        endif
        if (d.lt.0.d0.and.delj.lt.0.d0) then
          if (kj.eq.1) then
          mdd=mdd+1
          sdd(mdd)=d*delj*evtocmi*w
          endif
          avgjdd(kj)=avgjdd(kj)+xkj
          deltaedjd(k,kj)=deltaedjd(k,kj)+w*d*delj*xkj
        elseif (d.gt.0.d0.and.delj.gt.0.d0) then
          if (kj.eq.1) then
          muu=muu+1
          suu(muu)=d*delj*evtocmi*w
          endif
          avgjuu(kj)=avgjuu(kj)+xkj
          deltaeuju(k,kj)=deltaeuju(k,kj)+w*d*delj*xkj
        elseif (d.lt.0.d0.and.delj.gt.0.d0) then
          if (kj.eq.1) then
          mdu=mdu+1
          sdu(mdu)=d*delj*evtocmi*w
          endif
          avgjdu(kj)=avgjdu(kj)+xkj
          deltaedju(k,kj)=deltaedju(k,kj)+w*d*delj*xkj
        elseif (d.gt.0.d0.and.delj.lt.0.d0) then
          if (kj.eq.1) then
          mud=mud+1
          sud(mud)=d*delj*evtocmi*w
          endif
          avgjud(kj)=avgjud(kj)+xkj
          deltaeujd(k,kj)=deltaeujd(k,kj)+w*d*delj*xkj
        endif
        enddo
        enddo
        ENDIF
      enddo

      print *
      print *,"N traj = ",nt
      print *,"N E down = ",md," (",
     &    (dble(md)/dble(nt))*100.," %)",md,mu,md+mu,wd,wu,wd+wu
      print *,"N J down = ",mjd," (",
     &    (dble(mjd)/dble(nt))*100.," %)",mjd,mju,mjd+mju

      dn=dble(nt)
      etriav = etriav/dn
      ttav = ttav/dn
      etotiav = etotiav/dn
      etotdmue = etotdmue/dn
      etotdrms = dsqrt(etotdrms/dn)
      avgediffi = avgediffi/dn
      avgedifff = avgedifff/dn
      eeiavg=eeiavg/dn
      xjavg=xjavg/dn

      do i=1,nttt
      do k=1,3
      deltae(i,k) = deltae(i,k)/dn*evtocmi
      deltaej(i,k) = deltaej(i,k)/dn*evtocmi
      deltae2(i,k) = deltae2(i,k)/dn*evtocmi**2
      deltae3(i,k) = deltae3(i,k)/dn*evtocmi**3
      deltaed(i,k) = deltaed(i,k)/dble(md)*evtocmi
      deltaed2(i,k) = deltaed2(i,k)/dble(md)*evtocmi**2
      deltaed3(i,k) = deltaed3(i,k)/dble(md)*evtocmi**3
      deltaeu(i,k) = deltaeu(i,k)/dble(mu)*evtocmi
      deltaeu2(i,k) = deltaeu2(i,k)/dble(mu)*evtocmi**2
      deltaeu3(i,k) = deltaeu3(i,k)/dble(mu)*evtocmi**3

      deltaj(i,k) = deltaj(i,k)/dn
      deltaj2(i,k) = deltaj2(i,k)/dn
      deltaj3(i,k) = deltaj3(i,k)/dn
      deltajd(i,k) = deltajd(i,k)/dble(mjd)
      deltajd2(i,k) = deltajd2(i,k)/dble(mjd)
      deltajd3(i,k) = deltajd3(i,k)/dble(mjd)
      deltaju(i,k) = deltaju(i,k)/dble(mju)
      deltaju2(i,k) = deltaju2(i,k)/dble(mju)
      deltaju3(i,k) = deltaju3(i,k)/dble(mju)

      deltaedjd(i,k) = deltaedjd(i,k)/dble(mdd)*evtocmi
      deltaeuju(i,k) = deltaeuju(i,k)/dble(muu)*evtocmi
      deltaedju(i,k) = deltaedju(i,k)/dble(mdu)*evtocmi
      deltaeujd(i,k) = deltaeujd(i,k)/dble(mud)*evtocmi
      enddo
      enddo

      bav = bav/dn

      print *
      print *,"2x<bi> = ",(2.d0*bav)," (",bmax,")"
      print *
      print *," <Etot>i = ",etotiav," eV"
      print *," <Etr>i  = ",etriav," eV"
      print *," <Eint>i = ",(etotiav-etriav)," eV"
      print *
      print *," E conservation (cm-1):"
      print *,"    MUE ",(etotdmue*evtocmi)
      print *,"    RMS ",(etotdrms*evtocmi)
      print *,"    max ",(etotdmax*evtocmi)," traj ",itetotdmax
      print *
      print *," Vi diff (cm-1): max =",maxediffi*evtocmi,
     & ", mue =",avgediffi*evtocmi," traj #",maxediffitraj
      print *," Vf diff (cm-1): max =",maxedifff*evtocmi,
     & ", mue =",avgedifff*evtocmi," traj #",maxediffftraj
      print *
      print *," Max DE (cm-1) = ",(maxd*evtocmi)," (traj # ",maxdit,")"
      print *," Min DE (cm-1) = ",(mind*evtocmi)," (traj # ",mindit,")"
      print *
c      write(6,'(9a)')"     T(K)    NEdown    NEup     <DE>     ",
c     & "<DE2>^.5  -<DEd>   <DEd2>^.5   <DEu>   <DEu2>^.5 ",
c     & "   NJdown      NJup    <DJ>    <DJ2>^.5   -<DJd> ",
c     & "   <DJd2>^.5 <DJu>     <DJu2>^.5"
      do i=1,nttt
c      write(6,100)ttt(i),md,mu,deltae(i),deltae2(i),-deltaed(i),
c     & deltaed2(i),deltaeu(i),deltaeu2(i),mjd,mju,
c     &                   deltaj(i),deltaj2(i),-deltajd(i),deltajd2(i),
c     &                   deltaju(i),deltaju2(i)
c 100  format(f8.1,2i10,6f10.3,2i10,6f10.3)
      write(6,'(100a13)')"T(K)","ZLJ,cm3/s","Ntot","E',eV","J'",
     & "NEd","-<DEd>","<DEd2>",
     & "NEu","<DEu>","<DEu2>",
     & "NJd","-<DJd>","<DJd2>",
     & "NJu","<DJu>","<DJu2>",
     & "NEdJd","<DEdDJd>","NEuJu","<DEuJu>",
     & "NEdJu","-<DEdDJu>","NEuJd","-<DEuJd>"
      do k=1,1
      write(6,101)ttt(i),zlj(i),ntraj,eeiavg,xjavg,
     &  md,-deltaed(i,k),deltaed2(i,k),
     &  mu,deltaeu(i,k),deltaeu2(i,k),
     &  mjd,-deltajd(i,k),deltajd2(i,k),
     &  mju,deltaju(i,k),deltaju2(i,k),
     &  mdd,deltaedjd(i,k),muu,deltaeuju(i,k),
     &  mdu,-deltaedju(i,k),mud,-deltaeujd(i,k)
      enddo
      do k=1,jdble
      print *,"<<x J'^",k-1,">>"
      write(6,101)ttt(i),zlj(i),nint(avgj(1)),eeiavg,xjavg,
     &  nint(avgjed(1)),
     &   -deltaed(i,k)*avgjed(1)/avgjed(k),
     7   deltaed2(i,k)*avgjed(1)/avgjed(k),
     &  nint(avgjeu(1)),
     &    deltaeu(i,k)*avgjeu(1)/avgjeu(k),
     &   deltaeu2(i,k)*avgjeu(1)/avgjeu(k),
     &  nint(avgjjd(1)),
     &   -deltajd(i,k)*avgjjd(1)/avgjjd(k),
     &   deltajd2(i,k)*avgjjd(1)/avgjjd(k),
     &  nint(avgjju(1)),
     &    deltaju(i,k)*avgjju(1)/avgjju(k),
     &   deltaju2(i,k)*avgjju(1)/avgjju(k),
     &  nint(avgjdd(1)),deltaedjd(i,k)*avgjdd(1)/avgjdd(k),
     7  nint(avgjuu(1)),deltaeuju(i,k)*avgjuu(1)/avgjuu(k),
     &  nint(avgjdu(1)),-deltaedju(i,k)*avgjdu(1)/avgjdu(k),
     &  nint(avgjud(1)),-deltaeujd(i,k)*avgjud(1)/avgjud(k)
      enddo
      enddo
 101  format(f13.1,e13.5,i13,2f13.3,4(i13,2f13.3),4(i13,f13.3))

      print *,"     emomq(1,-1,0) =",deltaed(1,1)
      print *,"     emomq(2,-1,0) =",dsqrt(deltaed2(1,1))
      print *,"     emomq(1,1,0) =",deltaeu(1,1)
      print *,"     emomq(2,1,0) =",dsqrt(deltaeu2(1,1))
      print *,"     emomq(1,0,0) =",deltae(1,1)
      print *,"     emomq(2,0,0) =",dsqrt(deltae2(1,1))
      print *,"     emomq(1,-1,1) =",deltaed(1,2)*avgjed(1)/avgjed(2)
      print *,"     emomq(2,-1,1) =",
     &                        dsqrt(deltaed2(1,2)*avgjed(1)/avgjed(2))
      print *,"     emomq(1,1,1) =",deltaeu(1,2)*avgjeu(1)/avgjeu(2)
      print *,"     emomq(2,1,1) =",
     &                        dsqrt(deltaeu2(1,2)*avgjeu(1)/avgjeu(2))
      print *,"     emomq(1,0,1) =",deltae(1,2)*avgj(1)/avgj(2)
      print *,"     emomq(2,0,1) =",dsqrt(deltae2(1,2)*avgj(1)/avgj(2))
      print *,"     emomq(1,-1,2) =",deltaed(1,3)*avgjed(1)/avgjed(3)
      print *,"     emomq(2,-1,2) =",
     &                        dsqrt(deltaed2(1,3)*avgjed(1)/avgjed(3))
      print *,"     emomq(1,1,2) =",deltaeu(1,3)*avgjeu(1)/avgjeu(3)
      print *,"     emomq(2,1,2) =",
     &                        dsqrt(deltaeu2(1,3)*avgjeu(1)/avgjeu(3))
      print *,"     emomq(1,0,2) =",deltae(1,3)*avgj(1)/avgj(3)
      print *,"     emomq(2,0,2) =",dsqrt(deltae2(1,3)*avgj(1)/avgj(3))

      print *,"     jmomq(1,-1,0) =",deltajd(1,1)
      print *,"     jmomq(2,-1,0) =",dsqrt(deltajd2(1,1))
      print *,"     jmomq(1,1,0) =",deltaju(1,1)
      print *,"     jmomq(2,1,0) =",dsqrt(deltaju2(1,1))
      print *,"     jmomq(1,0,0) =",deltaj(1,1)
      print *,"     jmomq(2,0,0) =",dsqrt(deltaj2(1,1))
      print *,"     jmomq(1,-1,1) =",deltajd(1,2)*avgjjd(1)/avgjjd(2)
      print *,"     jmomq(2,-1,1) =",
     &                        dsqrt(deltajd2(1,2)*avgjjd(1)/avgjjd(2))
      print *,"     jmomq(1,1,1) =",deltaju(1,2)*avgjju(1)/avgjju(2)
      print *,"     jmomq(2,1,1) =",
     &                        dsqrt(deltaju2(1,2)*avgjju(1)/avgjju(2))
      print *,"     jmomq(1,0,1) =",deltaj(1,2)*avgj(1)/avgj(2)
      print *,"     jmomq(2,0,1) =",dsqrt(deltaj2(1,2)*avgj(1)/avgj(2))
      print *,"     jmomq(1,-1,2) =",deltajd(1,3)*avgjjd(1)/avgjjd(3)
      print *,"     jmomq(2,-1,2) =",
     &                        dsqrt(deltajd2(1,3)*avgjjd(1)/avgjjd(3))
      print *,"     jmomq(1,1,2) =",deltaju(1,3)*avgjju(1)/avgjju(3)
      print *,"     jmomq(2,1,2) =",
     &                        dsqrt(deltaju2(1,3)*avgjju(1)/avgjju(3))
      print *,"     jmomq(1,0,2) =",deltaj(1,3)*avgj(1)/avgj(3)
      print *,"     jmomq(2,0,2) =",dsqrt(deltaj2(1,3)*avgj(1)/avgj(3))

      print *,"     ejmomq(1,1) =",deltaedjd(1,1)
      print *,"     ejmomq(1,2) =",deltaedju(1,1)
      print *,"     ejmomq(1,3) =",deltaeujd(1,1)
      print *,"     ejmomq(1,4) =",deltaeuju(1,1)
      print *,"     ejmomq(1,5) =",deltaej(1,1)

c call binw
c      call binw(dnd,mdat,ded,dwd)

c      tmp = 133.322/(1.3806504E-23*ttt(i))*0.000001*zlj(i)

c     Uncertainty
        call boot(mm,mdat,sm,avg,sig)
        write(6,'(a10,3f15.5)')'<DE>',avg,sig,(sig/avg)*100.d0

        call boot(md,mdat,sd,avg,sig)
        write(6,'(a10,3f15.5)')'<DEd>',avg,sig,(sig/avg)*100.d0

        call boot(md,mdat,sd2,avg,sig)
        write(6,'(a10,3f15.5)')'<DEd2>',avg,sig,(sig/avg)*100.d0

        call boot(mu,mdat,su,avg,sig)
        write(6,'(a10,3f15.5)')'<DEu>',avg,sig,(sig/avg)*100.d0

        call boot(mu,mdat,su2,avg,sig)
        write(6,'(a10,3f15.5)')'<DEu2>',avg,sig,(sig/avg)*100.d0

        call boot(mjd,mdat,sjd,avg,sig)
        write(6,'(a10,3f15.5)')'<DJd>',avg,sig,(sig/avg)*100.d0

        call boot(mjd,mdat,sjd2,avg,sig)
        write(6,'(a10,3f15.5)')'<DJd2>',avg,sig,(sig/avg)*100.d0

        call boot(mju,mdat,sju,avg,sig)
        write(6,'(a10,3f15.5)')'<DJu>',avg,sig,(sig/avg)*100.d0

        call boot(mju,mdat,sju2,avg,sig)
        write(6,'(a10,3f15.5)')'<DJu2>',avg,sig,(sig/avg)*100.d0

        call boot(mdd,mdat,sdd,avg,sig)
        write(6,'(a10,3f15.5)')'<DEdJd>',avg,sig,(sig/avg)*100.d0

        call boot(muu,mdat,suu,avg,sig)
        write(6,'(a10,3f15.5)')'<DEuJu>',avg,sig,(sig/avg)*100.d0

        call boot(mdu,mdat,sdu,avg,sig)
        write(6,'(a10,3f15.5)')'<DEdJu>',avg,sig,(sig/avg)*100.d0

        call boot(mud,mdat,sud,avg,sig)
        write(6,'(a10,3f15.5)')'<DEuJd>',avg,sig,(sig/avg)*100.d0

      end

      subroutine boot(nd,md,dd,avg,sig)

      implicit double precision(a-h,o-z)
      dimension dd(md),avgi(100000)
      integer*4 timeArray(3)

      call itime(timeArray)     ! Get the current time
      iseed = timeArray(1)+timeArray(2)+timeArray(3)
      x=rand(iseed)

      nsamp=10000

      avgavg=0.
      do j=1,nsamp
        tot=0
        do i=1,nd
          irand=int(rand()*dble(nd))+1;
          v=dd(irand)
          tot=tot+v
        enddo
        avg = tot/dble(nd)
        avgi(j)=avg
        avgavg=avgavg+avg
      enddo
      avgavg=avgavg/dble(nsamp)

      std=0.
      do j=1,nsamp
        std=std+(avgi(j)-avgavg)**2
      enddo
      std=std/dble(nsamp-1)
      std=dsqrt(std)

      avg=avgavg
      sig=std

      return
      end

      subroutine binw(nd,md,dd,ww)

      implicit double precision(a-h,o-z)
      parameter(maxbin=20000)
      dimension dd(md),ww(md),nbin(maxbin),wbin(maxbin)

      evtocmi = 8065.7208

        demax=dd(1)
        demin=dd(1)
        do i=1,nd
          demax=max(dd(i),demax)
          demin=min(dd(i),demin)
        enddo

        do i=1,maxbin
         nbin(i)=0
         wbin(i)=0.d0
        enddo
        binsize = (demax-demin)/dble(nb)

        demin=-4020
        demax=4020
        demin=-8000
        demax=8000
        binsize=50.
        nb=(demax-demin)/binsize
        if (nb.gt.maxbin) print *,nb,maxbin
        if (nb.gt.maxbin) stop
        demin=demin-binsize

        wtot=0.d0
        do i=1,nd
          ib = int((dd(i)-demin)/binsize)
          if (ib.lt.nb.and.ib.gt.0) then
          nbin(ib)=nbin(ib)+1
          wbin(ib)=wbin(ib)+ww(i)
          wtot=wtot+ww(i)
c          print *,dble(ib)*binsize+demin,
c     &      dble(ib+1)*binsize+demin,dd(i)
          endif
        enddo

        eup=0.d0
        eup2=0.d0
        wup=0.d0
        edown=0.d0
        edown2=0.d0
        wdown=0.d0
        e0=0.d0
        e02=0.d0
        w0=0.d0
        do i=1,nb
          a=dble(i)*binsize+demin
          b=dble(i+1)*binsize+demin
          c=(a+b)/2.d0
c          print  *,i,c,dble(nbin(i))/dble(nd),nbin(i),nd,wbin(i)/wtot
          print  *,i,c,wbin(i)/wtot
          if (c.gt.0) then
               eup=eup+wbin(i)/wtot*c
               eup2=eup2+wbin(i)/wtot*c**2
               wup=wup+wbin(i)/wtot
          elseif (c.lt.0) then
               edown=edown+wbin(i)/wtot*c
               edown2=edown2+wbin(i)/wtot*c**2
               wdown=wdown+wbin(i)/wtot
          else
               e0=e0+wbin(i)/wtot*c
               e02=e02+wbin(i)/wtot*c**2
               w0=w0+wbin(i)/wtot
          endif
        enddo

        print *,"tot down up down2 up2 ",
     &                 (e0+edown+eup)/(w0+wdown+wup),
     &                  edown/wdown,eup/wup,
     &                  edown2/wdown,eup2/wup
        print *,"tot down up down2 up2 ",
     &                 (e0+edown+eup)/(w0+wdown+wup),
     &                  edown/(wdown+.5*w0),eup/(wup+.5*w0),
     &                  edown2/(wdown+.5*w0),eup2/(wup+.5*w0)

c         stop

        return
        end

